/**
	Haed a free program maker and generator
	Copyright (C) 2018  Florian Evaldsson

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#define MAIN_FILE
#include "includes.h"

/**
	THE MAIN FUNCTION!
	
	@param argc .
		Number of input arguments
	@param argv NO_FREE
		A char vector with the input args
	@return
		0=on success
		other=fail
*/
int main(int argc, char *argv[])
{	
	//init the global information
	haed_globalinfo_add_program(&HAED_GLOBAL_INFORMATION,"untitled");
	
	//icons for defining which type of oject you are trying to place
	MAIN_LevelEditor_ListObjectsIconsImage=(GtkWidget**)malloc(sizeof(GtkWidget*)*(1+1));


	gtk_init(&argc, &argv);

	MAIN_WINDOW = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_default_size(GTK_WINDOW(MAIN_WINDOW), 600, 400);
	//gtk_window_set_title(GTK_WINDOW(MAIN_WINDOW), "Haed");
	gtk_window_set_icon(GTK_WINDOW(MAIN_WINDOW), gdk_pixbuf_new_from_file("./images/icon.ico",NULL));
	g_signal_connect(MAIN_WINDOW, "destroy", G_CALLBACK(gtk_main_quit), NULL);
	
	GtkWidget *titlebar=gtk_header_bar_new();
	gtk_header_bar_set_title(GTK_HEADER_BAR(titlebar),"Haed");
	gtk_header_bar_set_subtitle(GTK_HEADER_BAR(titlebar),"New file");
	gtk_header_bar_set_show_close_button(GTK_HEADER_BAR(titlebar),TRUE);
	gtk_window_set_titlebar(GTK_WINDOW(MAIN_WINDOW),titlebar);
	
	//DEFINE ALL ELEMENTS
	MAIN_Box = gtk_box_new(GTK_ORIENTATION_VERTICAL,4);
	
		//Define and place the menu
		DefineTopMenuGui();
		
		//Define and place the menubuttons (toolbar)
		DefineButtonsMenuGui();
		
		//THE NOTEBOOK FOR SWITCHING AROUND BETWEEN LEVEL_EDITOR STORYBOARD TRIGGER_EDITOR
		MAIN_Notebook=gtk_notebook_new();
			HAED_GLOBAL_STORY_BOARD=gtk_box_new(GTK_ORIENTATION_VERTICAL,1);
			//STORYBOARD
			
			GtkWidget *STORYBOARD_NB_LABEL_BOX=gtk_box_new(GTK_ORIENTATION_HORIZONTAL,4);

				GdkPixbuf *STORYBOARD_PIXBUF=gdk_pixbuf_new_from_file_at_scale("./images/main/storyboard.png",16,16,1,NULL);
				gtk_box_pack_start(GTK_BOX(STORYBOARD_NB_LABEL_BOX),gtk_image_new_from_pixbuf(STORYBOARD_PIXBUF),0,1,0);
				gtk_box_pack_start(GTK_BOX(STORYBOARD_NB_LABEL_BOX),gtk_label_new("StoryBoard"),0,1,0);
				
				GtkWidget *separator=gtk_separator_new(GTK_ORIENTATION_VERTICAL);
				gtk_box_pack_start(GTK_BOX(STORYBOARD_NB_LABEL_BOX),separator,0,0,0);
				
				GtkWidget *button=gtk_button_new();
					gtk_button_set_image(GTK_BUTTON(button),gtk_image_new_from_file("./images/main/sound_manager2.png"));
					g_signal_connect (button, "clicked",G_CALLBACK (haed_dialog_sound_manager), 0);
				gtk_box_pack_start(GTK_BOX(STORYBOARD_NB_LABEL_BOX),button,0,0,0);
				
				gtk_widget_show_all(STORYBOARD_NB_LABEL_BOX);
			
			gtk_notebook_insert_page(GTK_NOTEBOOK(MAIN_Notebook),HAED_GLOBAL_STORY_BOARD,STORYBOARD_NB_LABEL_BOX,0);
			
			//LEVEL EDITOR
			//head
			MAIN_LAYOUT_aX=gtk_adjustment_new(0,0,600,2,2,1);
			MAIN_LAYOUT_aY=gtk_adjustment_new(0,0,400,2,2,1);
			
			//main
			MAIN_LevelEditor=gtk_box_new(GTK_ORIENTATION_VERTICAL,2);
				MAIN_LevelEditor_InnerBox=gtk_box_new(GTK_ORIENTATION_HORIZONTAL,2);
				gtk_widget_set_vexpand(MAIN_LevelEditor_InnerBox,1);
					
					MAIN_LevelEditor_Scrollbars[2]=gtk_scrollbar_new(GTK_ORIENTATION_VERTICAL,NULL);
					gtk_box_pack_start(GTK_BOX(MAIN_LevelEditor_InnerBox),MAIN_LevelEditor_Scrollbars[2],0,1,0);
					
					HAED_GLOBAL_LIST_OBJECTS=gtk_box_new(GTK_ORIENTATION_VERTICAL,0);
					gtk_box_pack_start(GTK_BOX(MAIN_LevelEditor_InnerBox),HAED_GLOBAL_LIST_OBJECTS,0,1,0);
					
					//LAYOUT
					GLOBAL_LEVEL_EDITOR_DRAWING_AREA = gtk_drawing_area_new ();
					gtk_widget_set_hexpand(GLOBAL_LEVEL_EDITOR_DRAWING_AREA,TRUE);
					gtk_widget_set_can_focus(GLOBAL_LEVEL_EDITOR_DRAWING_AREA,TRUE);
					gtk_widget_add_events (GLOBAL_LEVEL_EDITOR_DRAWING_AREA, GDK_ALL_EVENTS_MASK);
					g_signal_connect (GLOBAL_LEVEL_EDITOR_DRAWING_AREA, "draw",G_CALLBACK(haed_level_editor_signal_draw), NULL);
					g_signal_connect (GLOBAL_LEVEL_EDITOR_DRAWING_AREA, "event", G_CALLBACK (haed_level_editor_signal_event), 0);
					gtk_box_pack_start(GTK_BOX(MAIN_LevelEditor_InnerBox),GLOBAL_LEVEL_EDITOR_DRAWING_AREA,0,1,0);
						
					MAIN_LevelEditor_Scrollbars[0]=gtk_scrollbar_new(GTK_ORIENTATION_VERTICAL,MAIN_LAYOUT_aY);
					gtk_range_set_range(GTK_RANGE(MAIN_LevelEditor_Scrollbars[0]),0,100);
					g_signal_connect (MAIN_LevelEditor_Scrollbars[0], "value-changed", G_CALLBACK (haed_update_event_editor_placer), 0);
					gtk_box_pack_start(GTK_BOX(MAIN_LevelEditor_InnerBox),MAIN_LevelEditor_Scrollbars[0],0,1,0);
					
				gtk_box_pack_start(GTK_BOX(MAIN_LevelEditor),MAIN_LevelEditor_InnerBox,0,1,0);
				
				MAIN_LevelEditor_Scrollbars[1]=gtk_scrollbar_new(GTK_ORIENTATION_HORIZONTAL,MAIN_LAYOUT_aX);
				gtk_range_set_range(GTK_RANGE(MAIN_LevelEditor_Scrollbars[1]),0,100);
				g_signal_connect (MAIN_LevelEditor_Scrollbars[1], "value-changed", G_CALLBACK (haed_update_event_editor_placer), 0);
				gtk_box_pack_start(GTK_BOX(MAIN_LevelEditor),MAIN_LevelEditor_Scrollbars[1],0,1,0);
				
				GtkWidget *LEVEL_EDITOR_NB_LABEL_BOX=gtk_box_new(GTK_ORIENTATION_HORIZONTAL,4);

					GdkPixbuf *LEVEL_EDITOR_PIXBUF=gdk_pixbuf_new_from_file_at_scale("./images/main/level_editor.png",16,16,1,NULL);
					gtk_box_pack_start(GTK_BOX(LEVEL_EDITOR_NB_LABEL_BOX),gtk_image_new_from_pixbuf(LEVEL_EDITOR_PIXBUF),0,1,0);
					gtk_box_pack_start(GTK_BOX(LEVEL_EDITOR_NB_LABEL_BOX),gtk_label_new("Level Editor"),0,1,0);
					
					GtkWidget *testtt=gtk_separator_new(GTK_ORIENTATION_VERTICAL);
					gtk_box_pack_start(GTK_BOX(LEVEL_EDITOR_NB_LABEL_BOX),testtt,0,0,0);
					
					testtt=gtk_button_new();
						gtk_button_set_image(GTK_BUTTON(testtt),gtk_image_new_from_file("./images/main/new_object.png"));
						g_signal_connect (testtt, "clicked",G_CALLBACK (haed_draw_main_dialog), 0);
					gtk_box_pack_start(GTK_BOX(LEVEL_EDITOR_NB_LABEL_BOX),testtt,0,0,0);
					
					testtt=gtk_button_new();
						gtk_button_set_image(GTK_BUTTON(testtt),gtk_image_new_from_file("./images/main/pref.png"));
						g_signal_connect (testtt, "clicked",G_CALLBACK (haed_dialog_level_settings), 0);
					gtk_box_pack_start(GTK_BOX(LEVEL_EDITOR_NB_LABEL_BOX),testtt,0,0,1);
					
					gtk_widget_show_all(LEVEL_EDITOR_NB_LABEL_BOX);
			
			gtk_notebook_insert_page(GTK_NOTEBOOK(MAIN_Notebook),MAIN_LevelEditor,LEVEL_EDITOR_NB_LABEL_BOX,1);
			
			//EVENT EDITOR
			//misc general definitions for event editor
			HAED_GLOBAL_TRIGGER_BOX=gtk_box_new(GTK_ORIENTATION_VERTICAL,1);

				GtkWidget *EVENT_EDITOR_NB_LABEL_BOX=gtk_box_new(GTK_ORIENTATION_HORIZONTAL,4);

					GdkPixbuf *EVENT_EDITOR_PIXBUF=gdk_pixbuf_new_from_file_at_scale("./images/main/event_editor.png",16,16,1,NULL);
					gtk_box_pack_start(GTK_BOX(EVENT_EDITOR_NB_LABEL_BOX),gtk_image_new_from_pixbuf(EVENT_EDITOR_PIXBUF),0,1,0);
					gtk_box_pack_start(GTK_BOX(EVENT_EDITOR_NB_LABEL_BOX),gtk_label_new("Event Editor"),0,1,0);
					gtk_widget_show_all(EVENT_EDITOR_NB_LABEL_BOX);
				
			gtk_notebook_insert_page(GTK_NOTEBOOK(MAIN_Notebook),HAED_GLOBAL_TRIGGER_BOX,EVENT_EDITOR_NB_LABEL_BOX,2);
			
		gtk_box_pack_start(GTK_BOX(MAIN_Box),MAIN_Notebook,0,1,0);
		
	gtk_container_add(GTK_CONTAINER(MAIN_WINDOW),MAIN_Box);

	haed_storyboard_visual_reset(HAED_GLOBAL_INFORMATION.firstProgram->program);
	haed_triggers_visual_reset();
	haed_object_list_visual_reset();
	
	gtk_widget_show_all(MAIN_WINDOW);
	
	//MAIN LOOP
	gtk_main();
	
	return 0;
}
